#include <stdio.h>
#include <conio.h>

#define CR 0x0d		//carriage return
#define ESC 0x1b	//escape key
#define TAB 0x09
#define LF 0x0a		//line feed
#define BACKSPACE 0x08
#define NULL 0
#define TRUE 1
#define FALSE 0
#define LENGTH 15	//size of string

int input(char *string, int length);

void main()
{
	char string[LENGTH];

	printf("What is your name?");
	if (input(string,LENGTH))
		printf("Darn glad to meet you, %s!\n",string);
	else
		printf("It's just like you to go and cancel.\n");
}

int input(char *string,int length)
{
	int done = FALSE;
	int index = 0;
	char ch;

	string[0] = NULL;	//init the buffer

	do
	{
		ch = getch();

		if (index==length)
		{
			switch(ch)
			{
				case CR:
					break;
				case BACKSPACE:
					break;
				case ESC:
					break;
				default:
					ch = NULL;
					break;
			}
		}

		switch(ch)
		{
			case BACKSPACE:
				if (index==0)
				{
					break;
				}
				else
				{
					putchar(ch);
					putchar(' ');
					putchar(ch);
					index--;
					break;
				}
			case ESC:
				putchar(ch);
				putchar(LF);
				return (FALSE);
				break;
			case CR:
				putchar(ch);
				putchar(LF);
				string[index] = NULL;
				done = TRUE;
				break;
			case NULL:
				break;
			default:
				putchar(ch);
				string[index] = ch;
				index++;
				break;
		}
	}
	while(!done);

	return (TRUE);
}